#ifndef _koa2_5_bootloader_h
#define _koa2_5_bootloader_h

#include <unistd.h>
#include <termio.h>
#include "16-Bit Flash Programmer.h"

#define TRUE 1
#define FALSE 0

#define Sleep(val) (usleep(val*1000))




typedef struct rs232_s {
  
  /*! RS-232 device file descriptor */
  int fd;

  /*! */
  struct termios tios;

}
rs232_t;

int OpenConnection (rs232_t * rs232,  char *pPortName, speed_t BBaudRate);
int   WriteCommBlock (rs232_t * rs232, char *pBuffer ,  int BytesToWrite);
int    ReadCommBlock  (rs232_t * rs232, char *pBuffer,   int MaxLength);
bool   CloseConnection(rs232_t * rs232);

int    ReceiveData(rs232_t * rs232, char * pBuffer, int BytesToReceive);
int ReceiveDataTimeout(rs232_t * rs232, char * pBuffer, int BytesToReceive, long int timeout_ms);
void    PrintUsage(void);
eFamily ReadID(rs232_t * rs232);
void    ReadPM(rs232_t * rs232, char * pReadPMAddress, eFamily Family);
void    ReadEE(rs232_t * rs232, char * pReadEEAddress, eFamily Family);
void    SendHexFile(rs232_t * rs232, FILE * pFile, eFamily Family);

#endif
